Simplify / expand / factor an expression
Simplifies an algebraic expression, and also returns its expanded and factored forms.
Request
POSThttps://math-solver.p.apihiver.com/v1/simplify
JSON object. Required: expression.
Request Body
Edit the values below to test different scenarios.
Parameters and body structure are inherited from this endpoint's definition. Changes here only apply to this test run.
Language
Client
1curl --request POST \
2 --url https://math-solver.p.apihiver.com/v1/simplify \
3 --header 'Accept: application/json' \
4 --header 'Content-Type: application/json' \
5 --header 'X-API-Key: YOUR_API_KEY' \
6 --data '{
7 "expression": "(x^2-1)/(x-1)"
8}'Simplify / expand / factor an expression: Math Solver API reference
Simplifies an algebraic expression, and also returns its expanded and factored forms. This endpoint is part of the Math Solver API: Evaluate expressions, solve equations, and compute derivatives, integrals and simplifications — with exact and decimal answers.
Simplify / expand / factor an expression: example requests in every language
POST /v1/simplify in Shell (cURL)
curl --request POST \
--url https://math-solver.p.apihiver.com/v1/simplify \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--header 'X-API-Key: YOUR_API_KEY' \
--data '{
"expression": "(x^2-1)/(x-1)"
}'POST /v1/simplify in Shell (HTTPie)
echo '{
"expression": "(x^2-1)/(x-1)"
}' | \
http POST https://math-solver.p.apihiver.com/v1/simplify \
Accept:application/json \
Content-Type:application/json \
X-API-Key:YOUR_API_KEYPOST /v1/simplify in Shell (Wget)
wget --quiet \
--method POST \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'X-API-Key: YOUR_API_KEY' \
--body-data '{\n "expression": "(x^2-1)/(x-1)"\n}' \
--output-document \
- https://math-solver.p.apihiver.com/v1/simplifyPOST /v1/simplify in Node.js (http)
const http = require('https');
const options = {
method: 'POST',
hostname: 'math-solver.p.apihiver.com',
port: null,
path: '/v1/simplify',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
}
};
const req = http.request(options, function (res) {
const chunks = [];
res.on('data', function (chunk) {
chunks.push(chunk);
});
res.on('end', function () {
const body = Buffer.concat(chunks);
console.log(body.toString());
});
});
req.write(JSON.stringify({expression: '(x^2-1)/(x-1)'}));
req.end();POST /v1/simplify in Node.js (Request)
const request = require('request');
const options = {
method: 'POST',
url: 'https://math-solver.p.apihiver.com/v1/simplify',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
body: {expression: '(x^2-1)/(x-1)'},
json: true
};
request(options, function (error, response, body) {
if (error) throw new Error(error);
console.log(body);
});POST /v1/simplify in Node.js (Unirest)
const unirest = require('unirest');
const req = unirest('POST', 'https://math-solver.p.apihiver.com/v1/simplify');
req.headers({
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
});
req.type('json');
req.send({
expression: '(x^2-1)/(x-1)'
});
req.end(function (res) {
if (res.error) throw new Error(res.error);
console.log(res.body);
});POST /v1/simplify in Node.js (Axios)
const axios = require('axios').default;
const options = {
method: 'POST',
url: 'https://math-solver.p.apihiver.com/v1/simplify',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
data: {expression: '(x^2-1)/(x-1)'}
};
try {
const { data } = await axios.request(options);
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/simplify in Node.js (Fetch)
const fetch = require('node-fetch');
const url = 'https://math-solver.p.apihiver.com/v1/simplify';
const options = {
method: 'POST',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
body: '{"expression":"(x^2-1)/(x-1)"}'
};
try {
const response = await fetch(url, options);
const data = await response.json();
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/simplify in JavaScript (XMLHttpRequest)
const data = JSON.stringify({
expression: '(x^2-1)/(x-1)'
});
const xhr = new XMLHttpRequest();
xhr.withCredentials = true;
xhr.addEventListener('readystatechange', function () {
if (this.readyState === this.DONE) {
console.log(this.responseText);
}
});
xhr.open('POST', 'https://math-solver.p.apihiver.com/v1/simplify');
xhr.setRequestHeader('Content-Type', 'application/json');
xhr.setRequestHeader('Accept', 'application/json');
xhr.setRequestHeader('X-API-Key', 'YOUR_API_KEY');
xhr.send(data);POST /v1/simplify in JavaScript (Axios)
import axios from 'axios';
const options = {
method: 'POST',
url: 'https://math-solver.p.apihiver.com/v1/simplify',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
data: {expression: '(x^2-1)/(x-1)'}
};
try {
const { data } = await axios.request(options);
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/simplify in JavaScript (Fetch)
const url = 'https://math-solver.p.apihiver.com/v1/simplify';
const options = {
method: 'POST',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
body: '{"expression":"(x^2-1)/(x-1)"}'
};
try {
const response = await fetch(url, options);
const data = await response.json();
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/simplify in JavaScript (jQuery)
const settings = {
async: true,
crossDomain: true,
url: 'https://math-solver.p.apihiver.com/v1/simplify',
method: 'POST',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
processData: false,
data: '{\n "expression": "(x^2-1)/(x-1)"\n}'
};
$.ajax(settings).done(function (response) {
console.log(response);
});POST /v1/simplify in Python (http.client)
import http.client
conn = http.client.HTTPSConnection("math-solver.p.apihiver.com")
payload = "{\n \"expression\": \"(x^2-1)/(x-1)\"\n}"
headers = {
'Content-Type': "application/json",
'Accept': "application/json",
'X-API-Key': "YOUR_API_KEY"
}
conn.request("POST", "/v1/simplify", payload, headers)
res = conn.getresponse()
data = res.read()
print(data.decode("utf-8"))POST /v1/simplify in Python (Requests)
import requests
url = "https://math-solver.p.apihiver.com/v1/simplify"
payload = { "expression": "(x^2-1)/(x-1)" }
headers = {
"Content-Type": "application/json",
"Accept": "application/json",
"X-API-Key": "YOUR_API_KEY"
}
response = requests.post(url, json=payload, headers=headers)
print(response.json())POST /v1/simplify in PHP (cURL)

POST /v1/simplify in Swift (NSURLSession)
import Foundation
let headers = [
"Content-Type": "application/json",
"Accept": "application/json",
"X-API-Key": "YOUR_API_KEY"
]
let parameters = ["expression": "(x^2-1)/(x-1)"] as [String : Any]
let postData = JSONSerialization.data(withJSONObject: parameters, options: [])
let request = NSMutableURLRequest(url: NSURL(string: "https://math-solver.p.apihiver.com/v1/simplify")! as URL,
cachePolicy: .useProtocolCachePolicy,
timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data
let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
if (error != nil) {
print(error as Any)
} else {
let httpResponse = response as? HTTPURLResponse
print(httpResponse)
}
})
dataTask.resume()POST /v1/simplify in Objective-C (NSURLSession)
#import <Foundation/Foundation.h>
NSDictionary *headers = @{ @"Content-Type": @"application/json",
@"Accept": @"application/json",
@"X-API-Key": @"YOUR_API_KEY" };
NSDictionary *parameters = @{ @"expression": @"(x^2-1)/(x-1)" };
NSData *postData = [NSJSONSerialization dataWithJSONObject:parameters options:0 error:nil];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:@"https://math-solver.p.apihiver.com/v1/simplify"]
cachePolicy:NSURLRequestUseProtocolCachePolicy
timeoutInterval:10.0];
[request setHTTPMethod:@"POST"];
[request setAllHTTPHeaderFields:headers];
[request setHTTPBody:postData];
NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:request
completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
if (error) {
NSLog(@"%@", error);
} else {
NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *) response;
NSLog(@"%@", httpResponse);
}
}];
[dataTask resume];POST /v1/simplify in Kotlin (OkHttp)
val client = OkHttpClient()
val mediaType = MediaType.parse("application/json")
val body = RequestBody.create(mediaType, "{\n \"expression\": \"(x^2-1)/(x-1)\"\n}")
val request = Request.Builder()
.url("https://math-solver.p.apihiver.com/v1/simplify")
.post(body)
.addHeader("Content-Type", "application/json")
.addHeader("Accept", "application/json")
.addHeader("X-API-Key", "YOUR_API_KEY")
.build()
val response = client.newCall(request).execute()POST /v1/simplify in C (libcurl)
CURL *hnd = curl_easy_init();
curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, "POST");
curl_easy_setopt(hnd, CURLOPT_URL, "https://math-solver.p.apihiver.com/v1/simplify");
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Content-Type: application/json");
headers = curl_slist_append(headers, "Accept: application/json");
headers = curl_slist_append(headers, "X-API-Key: YOUR_API_KEY");
curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, "{\n \"expression\": \"(x^2-1)/(x-1)\"\n}");
CURLcode ret = curl_easy_perform(hnd);POST /v1/simplify in Clojure (clj-http)
(require '[clj-http.client :as client])
(client/post "https://math-solver.p.apihiver.com/v1/simplify" {:headers {:X-API-Key "YOUR_API_KEY"}
:content-type :json
:form-params {:expression "(x^2-1)/(x-1)"}
:accept :json})POST /v1/simplify in OCaml (CoHTTP)
open Cohttp_lwt_unix
open Cohttp
open Lwt
let uri = Uri.of_string "https://math-solver.p.apihiver.com/v1/simplify" in
let headers = Header.add_list (Header.init ()) [
("Content-Type", "application/json");
("Accept", "application/json");
("X-API-Key", "YOUR_API_KEY");
] in
let body = Cohttp_lwt_body.of_string "{\n \"expression\": \"(x^2-1)/(x-1)\"\n}" in
Client.call ~headers ~body `POST uri
>>= fun (res, body_stream) ->
(* Do stuff with the result *)POST /v1/simplify in R (httr)
library(httr)
url <- "https://math-solver.p.apihiver.com/v1/simplify"
payload <- "{\n \"expression\": \"(x^2-1)/(x-1)\"\n}"
encode <- "json"
response <- VERB("POST", url, body = payload, add_headers('X-API-Key' = 'YOUR_API_KEY'), content_type("application/json"), accept("application/json"), encode = encode)
content(response, "text")POST /v1/simplify in PowerShell (Invoke-WebRequest)
$headers=@{}
$headers.Add("Content-Type", "application/json")
$headers.Add("Accept", "application/json")
$headers.Add("X-API-Key", "YOUR_API_KEY")
$response = Invoke-WebRequest -Uri 'https://math-solver.p.apihiver.com/v1/simplify' -Method POST -Headers $headers -ContentType 'application/json' -Body '{
"expression": "(x^2-1)/(x-1)"
}'POST /v1/simplify in PowerShell (Invoke-RestMethod)
$headers=@{}
$headers.Add("Content-Type", "application/json")
$headers.Add("Accept", "application/json")
$headers.Add("X-API-Key", "YOUR_API_KEY")
$response = Invoke-RestMethod -Uri 'https://math-solver.p.apihiver.com/v1/simplify' -Method POST -Headers $headers -ContentType 'application/json' -Body '{
"expression": "(x^2-1)/(x-1)"
}'POST /v1/simplify in HTTP (HTTP/1.1)
POST /v1/simplify HTTP/1.1
Content-Type: application/json
Accept: application/json
X-Api-Key: YOUR_API_KEY
Host: math-solver.p.apihiver.com
Content-Length: 35
{
"expression": "(x^2-1)/(x-1)"
}Example response (200, application/json)
Success.
1{
2 "expanded": "x**2/(x - 1) - 1/(x - 1)",
3 "factored": "x + 1",
4 "expression": "(x^2-1)/(x-1)",
5 "simplified": "x + 1"
6}Errors
- 400 — A required parameter is missing or a value has the wrong format.
1{ 2 "error": { 3 "code": "INVALID_INPUT", 4 "message": "expression: Field required" 5 } 6}
Gateway errors (missing key, no subscription, rate limits) are listed in Error codes.